/**
 * My Title
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.AccountsRequest
import io.swagger.client.models.DeviceSummary
import io.swagger.client.models.DevicesRequest
import io.swagger.client.models.EventsRequest
import io.swagger.client.models.FilterableListOfAssociatedAccountSummary
import io.swagger.client.models.FilterableListOfDeviceSummary
import io.swagger.client.models.FilterableListOfEventSummary
import io.swagger.client.models.FilterableListOfSessionSummary
import io.swagger.client.models.LiveDeviceUpdate
import io.swagger.client.models.SessionEventsRequest
import io.swagger.client.models.SessionsRequest

import io.swagger.client.infrastructure.*

class DevicesServiceApi(basePath: kotlin.String = "http://localhost:8080") : ApiClient(basePath) {

    /**
     * 
     * 
     * @param body  
     * @return FilterableListOfAssociatedAccountSummary
     */
    @Suppress("UNCHECKED_CAST")
    fun devicesServiceGetAccountsByFilter(body: AccountsRequest): FilterableListOfAssociatedAccountSummary {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/db/accounts/filtered"
        )
        val response = request<FilterableListOfAssociatedAccountSummary>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as FilterableListOfAssociatedAccountSummary
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param id  (optional)
     * @param projectId  (optional)
     * @return DeviceSummary
     */
    @Suppress("UNCHECKED_CAST")
    fun devicesServiceGetDeviceSummaryByCode(id: kotlin.String? = null, projectId: kotlin.String? = null): DeviceSummary {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (id != null) {
                put("id", listOf(id.toString()))
            }
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/api/db/device/exact", query = localVariableQuery
        )
        val response = request<DeviceSummary>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as DeviceSummary
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return FilterableListOfDeviceSummary
     */
    @Suppress("UNCHECKED_CAST")
    fun devicesServiceGetDevicesByFilter(body: DevicesRequest): FilterableListOfDeviceSummary {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/db/devices/filtered"
        )
        val response = request<FilterableListOfDeviceSummary>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as FilterableListOfDeviceSummary
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return FilterableListOfEventSummary
     */
    @Suppress("UNCHECKED_CAST")
    fun devicesServiceGetEventsByFilter(body: EventsRequest): FilterableListOfEventSummary {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/db/all_events/filtered"
        )
        val response = request<FilterableListOfEventSummary>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as FilterableListOfEventSummary
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return LiveDeviceUpdate
     */
    @Suppress("UNCHECKED_CAST")
    fun devicesServiceGetEventsBySession(body: SessionEventsRequest): LiveDeviceUpdate {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/db/events"
        )
        val response = request<LiveDeviceUpdate>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as LiveDeviceUpdate
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return FilterableListOfSessionSummary
     */
    @Suppress("UNCHECKED_CAST")
    fun devicesServiceGetSessionsByFilter(body: SessionsRequest): FilterableListOfSessionSummary {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/db/sessions/filtered"
        )
        val response = request<FilterableListOfSessionSummary>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as FilterableListOfSessionSummary
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
